 /*
  * bitfont.cpp - Bitmap Font Blitting Object
  * Copyright (c)2004 Pawel Szymczykowski <pawel@makenai.net>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#include "bitfont.h"

BitFont::BitFont(unsigned char *data, int width, int height)
{ 
	this->font_data = data;
	this->font_width = width;
	this->font_height = height;
	this->font_byte_width = this->calc_byte_width(width);	
}

BitFont::~BitFont() { }

void BitFont::putchar(GPDRAWSURFACE *surface, int index, int x_pos, int y_pos, int color)
{
	putxbm(surface, x_pos, y_pos, this->font_data + (this->font_byte_width * this->font_height * index), 
		this->font_width, this->font_height, color);
	/*
	int x, y;
	unsigned char *moji = this->font_data + (this->font_byte_width * this->font_height * index);
	unsigned char mask = 1;

	for (y=0;y<this->font_height;y++) 
	{
		for (x=0;x<this->font_width;x++)
		{
			if (*moji & mask) GpPointSet(surface, x_pos + x, y_pos + y, color);
			if (!(mask<<=1)) { moji++; mask++; };	
		}
		//if (mask) { mask=1; moji++; };
	}
	*/
}

void BitFont::putchar_rev(GPDRAWSURFACE *surface, int index, int x_pos, int y_pos, int color)
{
	int x, y;
	unsigned char *moji = this->font_data + (this->font_byte_width * this->font_height * index);
	unsigned char mask = 1;

	for (y=0;y<this->font_height;y++) 
		for (x=0;x<this->font_width;x++)
		{
			if (!(*moji & mask)) GpPointSet(surface, x_pos + x, y_pos + y, color);
			if (!(mask<<=1)) { moji++; mask++; };	
		}
}


int BitFont::get_width() 
{ return(this->font_width); }

int BitFont::get_height() 
{ return(this->font_height); }

int BitFont::get_byte_width() 
{ return(this->font_byte_width); }

int BitFont::calc_byte_width(int width)
{ // Not very sophisticated.. but doesn't rely on FPU
	int bytes = width / 8;
	if ((bytes * 8) < width) bytes++;
	return(bytes);
}
